[FIX] test new_project: use temp file for config

- All addons script support config
- script/repo_revert_git_diff_date_from_code_generator support multi repo
This commit is contained in:
Mathieu Benoit 2022-02-10 00:40:56 -05:00
parent ffc06223b2
commit 5065dc2f2a
8 changed files with 111 additions and 72 deletions

View file

@ -6,8 +6,6 @@ import os
import sys import sys
from collections import defaultdict from collections import defaultdict
CONFIG_PATH = "./config.conf"
logging.basicConfig( logging.basicConfig(
format=( format=(
"%(asctime)s,%(msecs)d %(levelname)-8s [%(filename)s:%(lineno)d]" "%(asctime)s,%(msecs)d %(levelname)-8s [%(filename)s:%(lineno)d]"
@ -34,6 +32,12 @@ def get_config():
required=True, required=True,
help="Module name to search, a list can be use separate by ,", help="Module name to search, a list can be use separate by ,",
) )
parser.add_argument(
"-c",
"--config",
default="./config.conf",
help="The config path.",
)
parser.add_argument( parser.add_argument(
"--debug", "--debug",
action="store_true", action="store_true",
@ -49,18 +53,18 @@ def main():
logging.getLogger().setLevel(logging.DEBUG) logging.getLogger().setLevel(logging.DEBUG)
config_parser = configparser.ConfigParser() config_parser = configparser.ConfigParser()
config_parser.read(CONFIG_PATH) config_parser.read(config.config)
if "options" in config_parser: if "options" in config_parser:
if "addons_path" in config_parser["options"]: if "addons_path" in config_parser["options"]:
addons_path = config_parser["options"]["addons_path"] addons_path = config_parser["options"]["addons_path"]
else: else:
_logger.error( _logger.error(
"Missing item 'addons_path' in section 'options' in" "Missing item 'addons_path' in section 'options' in"
f" '{CONFIG_PATH}'" f" '{config.config}'"
) )
return -1 return -1
else: else:
_logger.error(f"Missing section 'options' in '{CONFIG_PATH}'") _logger.error(f"Missing section 'options' in '{config.config}'")
return -1 return -1
lst_addons_path = addons_path.split(",") lst_addons_path = addons_path.split(",")

View file

@ -1,13 +1,23 @@
#!/usr/bin/env bash #!/usr/bin/env bash
./script/addons/check_addons_exist.py -m "$2" # Argument 3 is config
if [[ $# -eq 3 ]]; then
./script/addons/check_addons_exist.py -m "$2" -c "$3"
else
./script/addons/check_addons_exist.py -m "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons.sh" echo "Error check_addons_exist.py into install_addons.sh"
exit 1 exit 1
fi fi
./run.sh --no-http --stop-after-init -d "$1" -i "$2" -u "$2" if [[ $# -eq 3 ]]; then
./run.sh --no-http --stop-after-init -d "$1" -i "$2" -u "$2" -c "$3"
else
./run.sh --no-http --stop-after-init -d "$1" -i "$2" -u "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons.sh" echo "Error run.sh into install_addons.sh"
exit 1 exit 1
fi fi

View file

@ -1,13 +1,23 @@
#!/usr/bin/env bash #!/usr/bin/env bash
./script/addons/check_addons_exist.py -m "$2" # Argument 3 is config
if [[ $# -eq 3 ]]; then
./script/addons/check_addons_exist.py -m "$2" -c "$3"
else
./script/addons/check_addons_exist.py -m "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons.sh" echo "Error check_addons_exist.py into install_addons_dev.sh"
exit 1 exit 1
fi fi
./run.sh --no-http --stop-after-init --dev qweb -d "$1" -i "$2" -u "$2" if [[ $# -eq 3 ]]; then
./run.sh --no-http --stop-after-init --dev qweb -d "$1" -i "$2" -u "$2" -c "$3"
else
./run.sh --no-http --stop-after-init --dev qweb -d "$1" -i "$2" -u "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons_dev.sh" echo "Error run.sh into install_addons_dev.sh"
exit 1 exit 1
fi fi

View file

@ -1,14 +1,28 @@
#!/usr/bin/env bash #!/usr/bin/env bash
./script/addons/check_addons_exist.py -m "$2" # Argument 3 is config
if [[ $# -eq 3 ]]; then
./script/addons/check_addons_exist.py -m "$2" -c "$3"
else
./script/addons/check_addons_exist.py -m "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons.sh" echo "Error check_addons_exist.py into reinstall_addons_dev.sh"
exit 1 exit 1
fi
if [[ $# -eq 3 ]]; then
./script/addons/uninstall_addons.sh "$1" "$2" "$3"
else
./script/addons/uninstall_addons.sh "$1" "$2"
fi
# Ignore if not uninstall
if [[ $# -eq 3 ]]; then
./script/addons/install_addons_dev.sh "$1" "$2" "$3"
else
./script/addons/install_addons_dev.sh "$1" "$2"
fi fi
./script/addons/uninstall_addons.sh "$1" "$2"
./script/addons/install_addons_dev.sh "$1" "$2"
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error reinstall_addons.sh" echo "Error install_addons_dev.sh into reinstall_addons.sh"
exit 1 exit 1
fi fi

View file

@ -1,8 +1,17 @@
#!/usr/bin/env bash #!/usr/bin/env bash
./script/addons/check_addons_exist.py -m "$2" # Argument 3 is config
if [[ $# -eq 3 ]]; then
./script/addons/check_addons_exist.py -m "$2" -c "$3"
else
./script/addons/check_addons_exist.py -m "$2"
fi
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error install_addons.sh" echo "Error check_addons_exist.py into uninstall_addons.sh"
exit 1 exit 1
fi
if [[ $# -eq 3 ]]; then
./run.sh --no-http --stop-after-init -d "$1" --uninstall "$2" "$3"
else
./run.sh --no-http --stop-after-init -d "$1" --uninstall "$2"
fi fi
./run.sh --no-http --stop-after-init -d "$1" --uninstall "$2"

View file

@ -3,31 +3,41 @@
# $2 is module name separate by , # $2 is module name separate by ,
# $3 is directory path to check # $3 is directory path to check
# $4 is generated module name separate by , # $4 is generated module name separate by ,
# $5 optional, the config path
if (($# < 4)); then if [[ $# -lt 4 ]]; then
echo "ERROR, need 4 arguments: 1-database name, 2-list of module to install, 3-directory to check difference, 4-list of generated module" echo "ERROR, need 4 arguments: 1-database name, 2-list of module to install, 3-directory to check difference, 4-list of generated module"
exit 1 exit 1
fi fi
INIT_DATETIME=$(date +%s) INIT_DATETIME=$(date +%s)
./script/addons/install_addons_dev.sh "$1" "$2" if [[ $# -eq 5 ]]; then
retVal=$? ./script/addons/install_addons_dev.sh "$1" "$2" "$5"
if [[ $retVal -ne 0 ]]; then retVal=$?
if [[ $retVal -ne 0 ]]; then
echo "Error ./script/addons/install_addons_dev.sh ${1} ${2} ${5}"
exit 1
fi
else
./script/addons/install_addons_dev.sh "$1" "$2"
retVal=$?
if [[ $retVal -ne 0 ]]; then
echo "Error ./script/addons/install_addons_dev.sh ${1} ${2}" echo "Error ./script/addons/install_addons_dev.sh ${1} ${2}"
exit 1 exit 1
fi
fi fi
# Check if the code was updated # Check if the code was updated
./script/code_generator/test_code_generator_update_module.py -m "$4" -d "$3" --datetime "${INIT_DATETIME}" ./script/code_generator/test_code_generator_update_module.py -m "$4" -d "$3" --datetime "${INIT_DATETIME}"
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error ./script/code_generator/test_code_generator_update_module.py ${4} ${3}" echo "Error ./script/code_generator/test_code_generator_update_module.py ${4} ${3}"
exit 1 exit 1
fi fi
# TODO check output when got warning # TODO check output when got warning
./script/repo_revert_git_diff_date_from_code_generator.py ./script/repo_revert_git_diff_date_from_code_generator.py --repo "$3"
# Remove pot and po diff # Remove pot and po diff
cd "$3" || exit 1 cd "$3" || exit 1
# git 2.22 and more, else use next command # git 2.22 and more, else use next command
@ -44,6 +54,6 @@ echo "TEST ${2}"
./script/code_generator/check_git_change_code_generator.sh "$3" ./script/code_generator/check_git_change_code_generator.sh "$3"
retVal=$? retVal=$?
if [[ $retVal -ne 0 ]]; then if [[ $retVal -ne 0 ]]; then
echo "Error ./script/code_generator/check_git_change_code_generator.sh" echo "Error ./script/code_generator/check_git_change_code_generator.sh"
exit 1 exit 1
fi fi

View file

@ -3,6 +3,7 @@ import argparse
import logging import logging
import os import os
import sys import sys
import tempfile
import uuid import uuid
from git import Repo from git import Repo
@ -73,14 +74,6 @@ def get_config():
action="store_true", action="store_true",
help="Force override directory and module.", help="Force override directory and module.",
) )
parser.add_argument(
"--do_not_update_config",
action="store_true",
help=(
"Ignore updating config file. This is a patch for a bug for"
" duplicate path, but 1 relative and the other is absolute."
),
)
parser.add_argument( parser.add_argument(
"--keep_bd_alive", "--keep_bd_alive",
action="store_true", action="store_true",
@ -105,11 +98,9 @@ class ProjectManagement:
template_name="", template_name="",
template_directory="", template_directory="",
force=False, force=False,
ignore_config=False,
keep_bd_alive=False, keep_bd_alive=False,
): ):
self.force = force self.force = force
self.ignore_config = ignore_config
self.keep_bd_alive = keep_bd_alive self.keep_bd_alive = keep_bd_alive
self.msg_error = "" self.msg_error = ""
self.origin_config_txt = "" self.origin_config_txt = ""
@ -233,6 +224,7 @@ class ProjectManagement:
git_repo.git.restore(relative_path) git_repo.git.restore(relative_path)
def generate_module(self): def generate_module(self):
# TODO copy directory in temp workspace file before update it
module_path = os.path.join(self.module_directory, self.module_name) module_path = os.path.join(self.module_directory, self.module_name)
if not self.force and not self.validate_path_ready_to_be_override( if not self.force and not self.validate_path_ready_to_be_override(
self.module_name, self.module_directory, path=module_path self.module_name, self.module_directory, path=module_path
@ -316,7 +308,7 @@ class ProjectManagement:
) )
): ):
return False return False
self.update_config() config_path = self.update_config()
bd_name_demo = f"new_project_code_generator_demo_{uuid.uuid4()}"[:63] bd_name_demo = f"new_project_code_generator_demo_{uuid.uuid4()}"[:63]
cmd = f"./script/db_restore.py --database {bd_name_demo}" cmd = f"./script/db_restore.py --database {bd_name_demo}"
@ -325,7 +317,7 @@ class ProjectManagement:
_logger.info("========= GENERATE code_generator_demo =========") _logger.info("========= GENERATE code_generator_demo =========")
cmd = ( cmd = (
f"./script/addons/install_addons_dev.sh {bd_name_demo}" f"./script/addons/install_addons_dev.sh {bd_name_demo}"
" code_generator_demo" f" code_generator_demo {config_path}"
) )
os.system(cmd) os.system(cmd)
@ -345,7 +337,6 @@ class ProjectManagement:
# Validate # Validate
if not os.path.exists(template_path): if not os.path.exists(template_path):
_logger.error(f"Module template not exists '{template_path}'") _logger.error(f"Module template not exists '{template_path}'")
self.revert_config()
return False return False
else: else:
_logger.info(f"Module template exists '{template_path}'") _logger.info(f"Module template exists '{template_path}'")
@ -379,14 +370,14 @@ class ProjectManagement:
os.system(cmd) os.system(cmd)
cmd = ( cmd = (
f"./script/addons/install_addons_dev.sh {bd_name_template}" f"./script/addons/install_addons_dev.sh {bd_name_template}"
f" {self.module_name}" f" {self.module_name} {config_path}"
) )
_logger.info(cmd) _logger.info(cmd)
os.system(cmd) os.system(cmd)
cmd = ( cmd = (
f"./script/addons/install_addons_dev.sh {bd_name_template}" f"./script/addons/install_addons_dev.sh {bd_name_template}"
f" {self.template_name}" f" {self.template_name} {config_path}"
) )
_logger.info(cmd) _logger.info(cmd)
os.system(cmd) os.system(cmd)
@ -402,7 +393,6 @@ class ProjectManagement:
# Validate # Validate
if not os.path.exists(cg_path): if not os.path.exists(cg_path):
_logger.error(f"Module cg not exists '{cg_path}'") _logger.error(f"Module cg not exists '{cg_path}'")
self.revert_config()
return False return False
else: else:
_logger.info(f"Module cg exists '{cg_path}'") _logger.info(f"Module cg exists '{cg_path}'")
@ -415,7 +405,7 @@ class ProjectManagement:
cmd = ( cmd = (
f"./script/addons/install_addons_dev.sh {bd_name_generator}" f"./script/addons/install_addons_dev.sh {bd_name_generator}"
f" {self.cg_name}" f" {self.cg_name} {config_path}"
) )
_logger.info(cmd) _logger.info(cmd)
os.system(cmd) os.system(cmd)
@ -431,17 +421,13 @@ class ProjectManagement:
# Validate # Validate
if not os.path.exists(template_path): if not os.path.exists(template_path):
_logger.error(f"Module not exists '{module_path}'") _logger.error(f"Module not exists '{module_path}'")
self.revert_config()
return False return False
else: else:
_logger.info(f"Module exists '{module_path}'") _logger.info(f"Module exists '{module_path}'")
self.revert_config()
return True return True
def update_config(self): def update_config(self):
if self.ignore_config:
return
# Backup config and restore it after, check if path exist or add it temporary # Backup config and restore it after, check if path exist or add it temporary
with open("./config.conf") as config: with open("./config.conf") as config:
config_txt = config.read() config_txt = config.read()
@ -462,14 +448,11 @@ class ProjectManagement:
if lst_directory_to_add: if lst_directory_to_add:
new_str = "addons_path = " + ",".join(lst_directory_to_add) + "," new_str = "addons_path = " + ",".join(lst_directory_to_add) + ","
config_txt = config_txt.replace("addons_path = ", new_str) config_txt = config_txt.replace("addons_path = ", new_str)
with open("./config.conf", "w") as config: temp_file = tempfile.mktemp()
config.write(config_txt) with open(temp_file, "w") as config:
config.write(config_txt)
def revert_config(self): print(f"mathben \n {temp_file} \n")
if self.ignore_config: return temp_file
return
with open("./config.conf", "w") as config:
config.write(self.origin_config_txt)
def main(): def main():
@ -482,7 +465,6 @@ def main():
cg_name=config.code_generator_name, cg_name=config.code_generator_name,
template_name=config.template_name, template_name=config.template_name,
force=config.force, force=config.force,
ignore_config=config.do_not_update_config,
keep_bd_alive=config.keep_bd_alive, keep_bd_alive=config.keep_bd_alive,
) )
if project.msg_error: if project.msg_error:

View file

@ -32,6 +32,10 @@ def get_config():
epilog="""\ epilog="""\
""", """,
) )
parser.add_argument(
"--repo",
default="./addons/TechnoLibre_odoo-code-generator-template;./addons/OCA_server-tools",
)
args = parser.parse_args() args = parser.parse_args()
return args return args
@ -43,11 +47,7 @@ def main():
r"[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])" r"[0-9]{4}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])"
r" (2[0-3]|[01][0-9]):[0-5][0-9]" r" (2[0-3]|[01][0-9]):[0-5][0-9]"
) )
# TODO support argument instead of hardcoded values lst_path = config.repo.split(";")
lst_path = [
"./addons/TechnoLibre_odoo-code-generator-template",
"./addons/OCA_server-tools",
]
for path in lst_path: for path in lst_path:
repo = git.Repo(path) repo = git.Repo(path)
supported_ext = [".xml", ".pot", ".po"] supported_ext = [".xml", ".pot", ".po"]